/*
TASK: katet
LANG: C++
*/
#include <cmath>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

long long x;
vector < int > s;

void read() {
	scanf ( "%lld" , &x );
}

int issquare ( long long a ) {
	long long t = (long long)sqrt ( (double)a );
	long long i;
	
	for (i = t - 2; i <= t + 2; i++)
		if ( i * i == a )
			return 1;
	
	return 0;
}

long long solve() {
	long long a;
	long long cnt = 0;
	
	for (a = 1; a <= 1000000; a++)
		if ( issquare ( a * a + x * x ) )
			++ cnt;
	
	return cnt;
}

long long fast() {
	long long p;
	long long a = x;
	long long ans = 1;
	int two = 0;
	int cnt;
	
	s.clear();
	
	for (p = 2; p * p <= a; p++) 
		if ( a % p == 0 ) {
			if ( p == 2 )
				two = 1;
			
			cnt = 0;
			
			while ( a % p == 0 ) {
				a /= p;
				++ cnt;
			}
			
			s.push_back ( cnt );
		}
		
	if ( a > 1 ) {
		if ( a == 2 ) two = 1;
		s.push_back ( 1 );
	}
	
	for (int i = 0; i < (int)s.size(); i++) {
		if ( two && !i ) 
			ans *= (long long)(2 * s[i] - 1);
		else
			ans *= (long long)(2 * s[i] + 1);
	}
	
	return ans / 2;
}

int main() {
	read();
	printf ( "%lld\n" , fast() );
	return 0;
	
	for (x = 1; x <= 10000; x++) {
		long long q = solve();
		long long w = fast();
		
		if ( q != w )
			printf ( "opaaa\n" );
		printf ( "%lld    %lld %lld\n" , x , q , w );
	}
	
	return 0;
}
