/*
LANG: C++
TASK: prox
*/
#include<iostream>
#include <cmath>
#define eps 1e-9
using namespace std;

typedef struct point
{
  double x, y;
  void read()
  {
   cin>>x>>y;
  }
};
    
    point A, B, C;
    
double D(point p1,point p2,point p3)
{
   return p1.x*(p2.y-p3.y)+p2.x*(p3.y-p1.y)+p3.x*(p1.y-p2.y);
}
double dist(point p1,point p2)
{
   double a, b;
   a = p1.x-p2.x;
   b = p1.y-p2.y;
   return a*a+b*b;
}
int sp(point p1,point p2,point p3)
{
   double a, b, c;
   c = dist(p1,p3);
   a = dist(p1,p2);
   b = dist(p3,p2);
   
   if(c > a + b)return -1; 
   else
   if( c == a + b)return 0;
   else return 1;
}
int main()
{
    A.read(); B.read(); C.read();
    
    point res;
    double dst = sqrt(dist(A, B));
    double x1, h, S, ac;
    S = fabs(D(A, B, C));
    h = S / dst; h *= h;
    ac = dist(A, C);
    //bc = sqrt(dist(B, C));
    
    
    x1 = sqrt(ac - h);
    //cout<<S<<" "<<h<<" "<<x1<<"\n";
    
    double fl;
    
    if(sp(C,A,B)<=0)
    {
                  //  printf("askdjs\n");
     cout<<A.x<<" "<<A.y<<"\n";
     return 0;
    }
    else
    if(sp(C,B,A)<=0)
    { //printf("askdjs22\n");
     cout<<B.x<<" "<<B.y<<"\n";
     return 0;
    }
    fl = 1;
    res.x = A.x + fl*((B.x - A.x)*x1)/dst;
    res.y = A.y + fl*((B.y - A.y)*x1)/dst;
    res.x+=eps;
    res.y+=eps;
    
    cout<<(int)res.x<<" "<<(int)res.y<<"\n";
return 0;
}
