/*
TASK: prox
LANG: C++
*/
#include <iostream>
#include <math.h>
#define eps 1e-9
#define eps2 -1e-9
using namespace std;

struct point
{
       int x, y;
       point(int _x, int _y):x(_x), y(_y){}
       point(){}
       point operator-(point p)
       {
             return point(x - p.x, y - p.y);
       }
};

double dist(point p1, point p2)
{
       return sqrt(((long long)p1.x-p2.x)*(p1.x-p2.x)+
                   ((long long)p1.y-p2.y)*(p1.y-p2.y));
}
long long dist2(point p1, point p2)
{
       return ((long long)p1.x-p2.x)*(p1.x-p2.x)+
              ((long long)p1.y-p2.y)*(p1.y-p2.y);

}
long long dot(point p1, point p2)
{
     return (long long)p1.x*p2.x + (long long)p1.y*p2.y;
}

int main()
{
    point A, B, C;
    cin >> A.x >> A.y >> B.x >> B.y >> C.x >> C.y;
    
    long long dot1 = dot(B-A, C-A);
    long long dot2 = dot(A-B, C-B);
    
    //cout << dot1 << " " << dot2 << endl;
    if (dot1 > 0 && dot2 > 0)
    {
    //double D = dot(B-A, C-A)/dist(A, B);
    //double k = D/dist(A, B);
    
    double k = (double)dot(B-A, C-A)/dist2(A, B);
    //cout << D << endl;
    double X = (double)A.x + k*(B.x - A.x);
    double Y = (double)A.y + k*(B.y - A.y);
    
    if (X < 0) X -= eps; else X += eps;
    if (Y < 0) Y -= eps; else Y += eps;
    
    cout << (int)(X) << " " << (int)(Y) << endl;
    return 0;
    }
    if (dot1 < 0) cout << A.x << " " << A.y << endl;
    else cout << B.x << " " << B.y << endl;
    return 0;
}
