
/*
TASK: katet
LANG: C++
*/

#include <cassert>
#include <vector>
#include <cstdio>
#include <iostream>
using namespace std;

inline bool prime(int x) {
    int d = 0;
    for (int i = 1; i <= x; ++i)
        if (x % i == 0)
            ++d;
    return d == 2;
}

long long solve(long long x) {
    int cnt = 0;
    long long y = x;
    for (long long i = 1; true; ++i) {
        while (i * i + x * x > y * y)
            ++y;
        if (i * i + x * x == y * y) {
            ++cnt;
//            printf("%lld %lld %lld\n", i, x, y);
        }
        if ((i + 1) * (i + 1) - i * i > x * x)
            break;
    }
    return cnt;
}

int main() {
  /*
//    for (int i = 1; true; ++i) {
//        printf("%d -- %d\n", i, solve(i));
//        fflush(stdout);
//    }
//    return 0;

    vector <int> all[128];

    long long x;
    scanf("%lld", &x);
    for (long long x = 1; x <= 1000; x += 2) {
        all[solve(x)].push_back(x); 
        if (solve(x) == 1 ^ prime(x)) {
        }
    }

    for (int i = 0; i < 128; ++i)
      if (all[i].size() > 0) {
        printf("With answer %d there are %d solutions: {", i, all[i].size());
        for (int j = 0; j < (int) all[i].size(); ++j)
          printf("%d, ", all[i][j]);
        puts("");
      }*/
//while (true) {
    long long x;
    cin >> x;

    if (x < 10000) {
        cout << solve(x) << endl;
    } else {
        int p[] = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79};
        if (x % 2 == 0) {
            cout << 1 << endl;
            return 0;
        }
        vector <int> all;
        for (long long i = 2; i * i <= x; ++i) {
            if (x % i != 0)
                continue;
            int cnt = 0;
            while (x % i == 0) {
                x /= i;
                ++cnt;
            }
            all.push_back(cnt);
        }
        if (x > 1)
            all.push_back(1);
        sort(all.rbegin(), all.rend());
//      for (int i = 0; i < (int) all.size(); ++i)
//          cout << all[i] << " ";
//      cout << endl;
        long long cur = 1;
        for (int i = 0; i < (int) all.size(); ++i) {
            for (int j = 1; j <= all[i]; ++j)
                cur *= p[i + 1];
        }
        cout << solve(cur) << endl;
    }
    return 0;
}
