/*
LANG: C++
TASK: katet
*/

#include <cstdio>
#include <cmath>

int isqrt(int i) {
    int res = (int)sqrt(i)+1;
    if(res*res == i) return res;
    --res;
    if(res*res == i) return res;
    --res;
    if(res*res == i) return res;
    return -1;
}

int solve(int c1) {
    int r = 0;
    for(int c2 = 1; c2 < 1000; ++c2) {
        if(isqrt(c2*c2+c1*c1) != -1) {
            ++r;
        }
    }
    return r;
}

int main() {
    /*for(int i = 1; i < 50; ++i) {
        printf("%d: %d\n", i, solve(i));
    }*/
    int n;
    scanf("%d", &n);
    printf("%d\n", solve(n));
    return 0;
}
