/*
TASK: sums
LANG: C++
*/
#include <iostream>
#define MAXN (1 << 11)
using namespace std;
typedef unsigned long long ull;

ull n , a , b , mod;
ull dp[MAXN][MAXN];

ull solve (int n , int k)
{
 if ( n < 0 || k <= 0 ) return 0;
 if (dp[n][k] != -1) return dp[n][k];
 if (n == 0) return 1 ;
 
 dp[n][k] = 0;
 for ( int i=a; i <= b && i <= k && i <= n; ++i)
  {
   dp[n][k] += solve ( n-i , i );
   if ( dp[n][k] > mod ) dp[n][k] %= mod;
  }
 
 return dp[n][k];
}

int main ()
{
 memset (dp , -1 , sizeof (dp));
 cin >> n >> a >> b >> mod;

 cout << solve ( n , b ) << endl;
 return 0;    
}
