/*
TASK: katet
LANG: C++
*/

#include <iostream>
using namespace std;

typedef unsigned long long LL;

const int MAX_N = 1 << 17;


LL x, ans;
LL dp[MAX_N][2];
int N, a[MAX_N];


void Read()
{
	cin >> x;
	
	if(x == 1)
	{
		cout << "0\n";
		exit(0);
	}
}

LL rec(int n, int border)
{
LL & ret = dp[n][border];
	
	if(0LL < ret) return ret;
	
	if(n + 1 == N)
	{
		if(border) return ret = (a[n]);
		else return ret = (2LL * a[n] + 1LL);
	}
	else
	{
		if(border) return ret = (a[n]) * rec(n + 1, 0) + rec(n + 1, 1);
		else return ret = (2LL * a[n] + 1LL) * rec(n + 1, 0);
	}
}

void Solve()
{
bool two = false;
	
	for(LL i = 2LL; i * i <= x; i ++)
	{
		if(x % i == 0LL)
		{
			while(x % i == 0LL)
			{
				x /= i;
				a[N] ++;
			}
			
			N ++;
			
			if(i == 2) two = true;
		}
	}
	
	if(x != 1LL)
	{
		if(x == 2LL) two = true;
		
		a[N] ++;
		N ++;
	}
	
/*
	cerr << "Array:\n";
	for(int i = 0; i < N; i ++)
		cerr << a[i] << "  ";
	cerr << "\n\n\n";
*/
	
	if(two)
	{
		if(N == 1) ans = a[0] - 1LL;
		else ans = rec(1, 1) * (2LL * a[0] - 1LL) + (a[0] - 1LL);
	}
	else
	{
		ans = rec(0, 1);
	}
}

void Write()
{
//	cerr << "Answer: " << ans << "\n";
	
	cout << ans << "\n";
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
//	fprintf(stderr, "%.5lf\n", double(clock()) / double(CLOCKS_PER_SEC));
//	system("pause");
	
	return 0;
}
