/*
TASK: sums
LANG: C++
*/
#include <cstdio>

const int MAXN = 1 << 14;

int n , a , b;
long long mod;
long long dp[MAXN];

void read() {
	scanf ( "%d%d%d%lld" , &n , &a , &b , &mod );
}

void solve() {
	int i , j;
	
	dp[0] = 1;
	for (j = a; j <= b; j++) 
		for (i = j; i <= n; i++) {
			dp[i] += dp[i - j];
			if ( dp[i] >= mod ) dp[i] -= mod;
		}
			
	printf ( "%lld\n" , dp[n] );
}

int main() {
	read();
	solve();
	
	return 0;
}
