/*
TASK:prox
LANG:C++
*/

#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <utility>
#include <numeric>
#include <functional>
#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <queue>

using namespace std;

#define F(i,n) for (int i=0;i<n;i++) 
#define Repi(n) F(i,n)
#define Repj(n) F(j,n)
#define Repk(n) F(k,n)
#define SZ size()
#define PB push_back
#define MP make_pair
#define x first
#define y second
#define VI vector<int>
#define LL long long
#define PI pair<int,int>
#define PD pair<double,double>
#define sqr(a) ((a)*(a))
#define ABS(x) (((x)>0)?(x):(-(x)))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define sign(x) (((x)>0)-((x)<0))
#define IT iterator

PD A,B,C;

double sp(PD A,PD B,PD C)
{
       double dx1=B.x-A.x;
       double dy1=B.y-A.y;
       double dx2=C.x-A.x;
       double dy2=C.y-A.y;
       return dx1*dx2+dy1*dy2;
}

double dist1(PD A,PD B)
{ return sqr(A.x-B.x)+sqr(A.y-B.y); }

int main()
{
    scanf("%lf %lf %lf %lf %lf %lf",&A.x,&A.y,&B.x,&B.y,&C.x,&C.y);
    
    //cout<<A.x<<" "<<A.y<<" ; "<<B.x<<" "<<B.y<<" ; "<<C.x<<" "<<C.y<<"\n";
    
    double ss=sp(A,B,C);
    double dd=dist1(A,B);
    
    double k=ss/dd;
    
   // cout<<ss<<" "<<dd<<" - "<<k<<"\n";
    if (k<0. || k>1.)
     {
             if (dist1(A,C)<dist1(B,C))
              printf("%d %d\n",(int)A.x,(int)A.y);
             else
              printf("%d %d\n",(int)B.x,(int)B.y);
     }
    else
     {
             PD D;
             D.x=(B.x-A.x)*k+A.x;
             D.y=(B.y-A.y)*k+A.y;
             int x,y;
             
             if (D.x>0) x=(int)floor(D.x+1e-10);
             else x=(int)ceil(D.x-1e-10);
             if (D.y>0) y=(int)floor(D.y+1e-10);
             else y=(int)ceil(D.y-1e-10);
             
             //printf("%.10lf %.10lf\n",D.x,D.y);
             printf("%d %d\n",x,y);
     }
    
	return 0;
}
