/*
TASK:prox
LANG:C++
*/
#include <iostream>
#include <cmath>
using namespace std;

struct point 
{
    double x, y;
    void read ()
    {
        scanf ("%lf%lf", &x, &y);
    }
};

point a, b, c;

double DDD(point p0, point p1, point p2)
{
    return (p1.x - p0.x)*(p2.y - p0.y) - (p2.x - p0.x) * (p1.y - p0.y);   
}

double dist (point p1, point p2)
{
    return sqrt( (p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y));
}

int main ()
{
    
    a.read(); b.read(); c.read();
 if (dist (b, c) > dist (a, c)) swap (a, b);
 double A = DDD(a, b, c) / dist(a, b);
 
 double C = dist(a, c);
 
 double B = sqrt (C*C - A*A);
 
 point res;
 double coef = B/dist (a, b);
  res.x = a.x + (b.x - a.x)* coef;
  res.y = a.y + (b.y - a.y)* coef;
  
  if (DDD(c, res, a)* DDD(c, res, b) < 0.0)
  cout << (long long)res.x<<" "<<(long long)res.y<<endl;
  else
  cout << (long long)b.x<<" "<<(long long)b.y<<endl;
  
    // system ("pause");
    return 0;
}
