/*
TASK:prox
LANG:C++
*/

#include <iostream>
#include <math.h>
using namespace std;
long long xa,xb,xc,ya,yb,yc;
long long A,B,C;

long long dist2(int x1,int y1,int x2,int y2)
{
     return (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2);     
}
long long S2()
{
     return  ((xb-xa)*(yc-ya)-(xc-xa)*(yb-ya))*((xb-xa)*(yc-ya)-(xc-xa)*(yb-ya));
}

int main()
{
    cin>>xa>>ya>>xb>>yb>>xc>>yc;
    if(xb<xa) {swap(xa,xb);swap(ya,yb);}
    if(ya==yb)
    {
              if(xc>xb) xc=xb;
              if(xc<xa) xc=xa;
              cout<<xc<<" "<<yb<<endl;
              return 0;          
    }
    if(xa==xb)
    {
              if(yc>max(ya,yb)) yc=max(ya,yb);
              if(yc<min(ya,yb)) yc=min(ya,yb);
              cout<<xa<<" "<<yc<<endl;
              return 0;
    }
        
    long long h2=S2()/dist2(xa,ya,xb,yb);
    long long AT2=dist2(xa,ya,xc,yc)-h2;
   // cout<<AT2<<" "<<S2()<<endl;
    double k=(double)(xb-xa)/(double)(yb-ya);    
    double y2=AT2/(1.+k*k);
    double y1=sqrt(y2);
    if(k<0) y1=-y1;
    double x1=k*y1;
  //  cout<<k<<" "<<x1<<" "<<y1<<endl;
  x1+=(double)xa;
  y1+=(double)ya;
  if(x1>xb) cout<<xb<<" "<<yb<<endl;
  else if(x1<xa) cout<<xa<<" "<<ya<<endl;
  else cout<<(int)(x1)<<" "<<(int)(y1)<<endl;
}
