/*
TASK: prox
LANG: C++
*/

#include <iostream>

double abs(double _x)
{
	return _x < -1e-9 ? -_x : _x;
}

long long abs(long long _x)
{
	return _x < 0 ? -_x : _x;
}

long long x1, y1, x2, y2, x3, y3;
double A, B, C;
int main()
{
	std :: cin >> x1 >> y1;
	std :: cin >> x2 >> y2;
	std :: cin >> x3 >> y3;
	if(x1 > x2)	
	{
		std :: swap(x1, x2);
		std :: swap(y1, y2);
	}
	A = y1 - y2;
	B = x2 - x1;
	C = x1 * y2 - x2 * y1;
	if(x1 == x2)		// vertical
	{
		if(y1 > y2)	std :: swap(y1, y2);
		int x4 = x1;
		int y4 = y3;
		if(y3 < y1)			y4 = y1;
		else if(y3 > y2)	y4 = y2;
		else				y4 = y3;
		std :: cout << x4 << " " << y4 << "\n";
		return 0;
	}
	double R = x3 * (x2 - x1) + y3 * (y2 - y1);
	R += C / B * (y2 - y1);
	double x4 = R / double(x2 - x1 - A / B * (y2 - y1));
	double y4 = (- A * x4 - C) / B;
	if( x4 < x1 )		x4 = x1, y4 = y1;
	else if( x4 > x2)	x4 = x2, y4 = y2;
	printf("%d %d\n", int(x4 + 1e-9), int(y4+1e-9));
    return 0;
}
