/*
TASK:prox
LANG:C++
*/

#include <iostream>
#include <cstdio>
#include <cmath>
using namespace std;

typedef pair <double, double> Point;
#define x first
#define y second
inline Point operator*(double c, Point p) { Point res; res.x=c*p.x; res.y=c*p.y; return res; }
inline double operator*(Point a, Point b) { return a.x*b.y-a.y*b.x; }
inline double dot(Point a, Point b) { return a.x*b.x+a.y*b.y; }
inline Point operator-(Point a, Point b) { Point res; res.x=a.x-b.x; res.y=a.y-b.y; return res; }

void print(Point p) { printf("%d %d\n", (int)p.x, (int)p.y); }
int main()
{
  Point a, b, c, ab, norm;
  cin>>a.x>>a.y>>b.x>>b.y>>c.x>>c.y;
  ab=b-a; norm.x=-(ab.y); norm.y=ab.x;
  
  double dist=ab*(c-a)/hypot(ab.x, ab.y);
  
  norm=dist/hypot(norm.x, norm.y)*norm;
  Point d=c-norm;
  
  if(dot(d-a, ab)<0) print(a);
  else if(dot(d-b, a-b)<0) print(b);
  else print(d);
  
  return 0;
}
