
/*
TASK: sums
LANG: C++
*/

#include <cstdio>
using namespace std;

const int MAX_N = 10000 + 5;

int A, B;
int N;
long long M;
long long dp[MAX_N];

void read() {
    scanf("%d %d %d %lld", &N, &A, &B, &M);
}

long long solve() {
    dp[0] = 1;
    for (int i = A; i <= B; ++i)
        for (int j = 0; i + j <= N; ++j) {
            dp[j + i] += dp[j];
            if (dp[j + i] >= M)
                dp[j + i] -= M;
        }
    return dp[N];
}

int main() {
    read();
    printf("%lld\n", solve());
    return 0;
}
