/*
TASK: prox
LANG: C++
*/

#include <cstdio>
#include <cmath>

#define MUL(x1,y1,x2,y2) (x1*x2 + y1*y2)

double min(double a, double b) {
    return a < b ? a : b;
}
double max(double a, double b) {
    return a > b ? a : b;
}

int main() {
    double ax, ay, bx, by, cx, cy;
    scanf("%lf%lf%lf%lf%lf%lf", &ax, &ay, &bx, &by, &cx, &cy);
    bx -= ax;
    by -= ay;
    cx -= ax;
    cy -= ay;

    if(bx*bx+by*by == 0) {
        printf("%d %d\n", (int)ax, (int)bx);
        return 0;
    }
    double mul = MUL(bx, by, cx, cy)/(bx*bx+by*by);

    double dx = bx*mul;
    double dy = by*mul;

    if(dx > max(bx, 0))
        dx = max(bx, 0);
    if(dx < min(bx, 0))
        dx = min(bx, 0);

    if(dy > max(by, 0))
        dy = max(by, 0);
    if(dy < min(by, 0))
        dy = min(by, 0);

    printf("%d %d\n", (int)(dx+ax), (int)(dy+ay));

    return 0;
}
