/*
TASK: sums
LANG: C++
*/

#include <cstdio>
#include <map>
#include <utility>
#include <cstring>
#include <climits>

using namespace std;

typedef unsigned long long lt;

int a;
lt m;

lt memo[2048][2048];

lt f(int n, int b) {
    if(n < 0) return 0;
    if(n == 0) return 1;

    if(memo[n][b] != ULLONG_MAX)
        return memo[n][b];

    lt sum = 0;
    for(int i = b; i >= a; --i) {
        sum += f(n-i, i);
        sum %= m;
        //printf("%llu\n", sum);
    }
    return memo[n][b] = sum;
}

int main() {
    memset(memo, -1, sizeof(memo));
    int n, b;
    scanf("%d%d%d%llu", &n, &a, &b, &m);
    printf("%llu\n", f(n, b));
    return 0;
}
