/*
TASK: sums
LANG: C++
*/

#include <iostream>
using namespace std;

typedef unsigned long long LL;

const int MAX_N = 10005;


int N, A, B;
LL dp[MAX_N], MOD;


void Read()
{
	cin >> N >> A >> B >> MOD;
}

void Solve()
{
	dp[0] = 1LL;
	
	for(int i = A; i <= B; i ++)
	{
		for(int j = 0; j <= N - i; j ++)
		{
			dp[j + i] += dp[j];
			
			if(MOD <= dp[j + i])
				dp[j + i] -= MOD;
		}
	}
}

void Write()
{
	cout << dp[N] << "\n";
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
//	fprintf(stderr, "%.5lf\n", double(clock()) / double(CLOCKS_PER_SEC));
//	system("pause");
	
	return 0;
}
